class
	P_AORSMUL_I_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBMPZ_ASSEMBLER

feature {ANY} -- public routines

	gmpz_aorsmul_1 (a_sub: INTEGER_32; a_w, a_x: CE_POINTER [PD_MPZ_STRUCT]; a_y: NATURAL_32)
		local
			l_sub: INTEGER_32
			l_xsize: INTEGER_32
			l_wsize: CE_ARRAY [INTEGER_32]
			l_wsize_signed: INTEGER_32
			l_new_wsize: INTEGER_32
			l_min_size: INTEGER_32
			l_dsize: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_wp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy: NATURAL_32
			l_cy2: NATURAL_32
			l_d: CE_POINTER [NATURAL_32]
			l_s: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp_2: CE_POINTER [NATURAL_32]
			l_tmp_3: CE_POINTER [NATURAL_32]
			l_ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy2_0: NATURAL_32
			l_d_0: CE_POINTER [NATURAL_32]
			l_s_0: CE_POINTER [NATURAL_32]
			l_n_0: INTEGER_32
			l_tmp_4: CE_POINTER [NATURAL_32]
			l_tmp_5: CE_POINTER [NATURAL_32]
			l_cy3: NATURAL_32
			l_ptr_dummy_0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_wsize.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_wp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_ptr_dummy_0.make (<<1>>)

			l_sub := a_sub
			l_xsize := (a_x.item.mp_size).to_integer_32
			if l_xsize = 0 then
				l_return := True
			elseif a_y = {NATURAL_32} 0 then
				l_return := True
			end
			if not l_return then
				l_sub := (l_sub).bit_xor (l_xsize)
				if l_xsize >= 0 then
					l_xsize := l_xsize
				else
					l_xsize := -l_xsize
				end
				l_wsize_signed := (a_w.item.mp_size).to_integer_32
				if l_wsize_signed = 0 then
					if (builtin_expect ((l_xsize + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_xsize + 1).do_nothing
					end
					l_wp.item := a_w.item.mp_d
					l_cy := (create {P_GMP_STATIC}).gmpn_mul_1 (l_wp.item, a_x.item.mp_d, l_xsize, a_y)
					l_wp.item[l_xsize] := l_cy
					l_xsize := l_xsize + (l_cy /= {NATURAL_32} 0).to_integer
					if l_sub >= 0 then
						a_w.item.mp_size := l_xsize.to_integer_32
					else
						a_w.item.mp_size := (-l_xsize).to_integer_32
					end
					l_return := True
				end
			end
			if not l_return then
				l_sub := (l_sub).bit_xor (l_wsize_signed)
				if l_wsize_signed >= 0 then
					l_wsize.item := l_wsize_signed
				else
					l_wsize.item := -l_wsize_signed
				end
				if l_wsize.item > l_xsize then
					l_new_wsize := l_wsize.item
				else
					l_new_wsize := l_xsize
				end
				if (builtin_expect ((l_new_wsize + 1 > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_new_wsize + 1).do_nothing
				end
				l_wp.item := a_w.item.mp_d
				l_xp := a_x.item.mp_d
				if l_wsize.item < l_xsize then
					l_min_size := l_wsize.item
				else
					l_min_size := l_xsize
				end
				if l_sub >= 0 then
					l_cy := (create {P_GMP_STATIC}).gmpn_addmul_1 (l_wp.item, l_xp, l_min_size, a_y)
					l_wp.item := l_wp.item + l_min_size
					l_xp := l_xp + l_min_size
					l_dsize := l_xsize - l_wsize.item
					if l_dsize /= 0 then
						if l_dsize > 0 then
							l_cy2 := (create {P_GMP_STATIC}).gmpn_mul_1 (l_wp.item, l_xp, l_dsize, a_y)
						else
							l_dsize := -l_dsize
							l_cy2 := (0).to_natural_32
						end
						l_cy := l_cy2 + ((create {P_GMP_STATIC}).gmpn_add_1 (l_wp.item, l_wp.item, l_dsize, l_cy))
					end
					l_wp.item[l_dsize] := l_cy
					l_new_wsize := l_new_wsize + (l_cy /= {NATURAL_32} 0).to_integer
				else
					l_cy := (create {P_GMP_STATIC}).gmpn_submul_1 (l_wp.item, l_xp, l_min_size, a_y)
					if l_wsize.item >= l_xsize then
						if l_wsize.item /= l_xsize then
							l_cy := (create {P_GMP_STATIC}).gmpn_sub_1 (l_wp.item + l_xsize, (l_wp.item + l_xsize), l_wsize.item - l_xsize, l_cy)
						end
						if l_cy /= {NATURAL_32} 0 then
							l_wp.item[l_new_wsize] := ((-l_cy.to_integer_32).to_natural_32).bit_not
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_d := l_wp.item
								l_s := l_wp.item
								l_n := l_new_wsize
								from
								until
									(l_break)
								loop
									l_break := False
									l_tmp_2 := l_d
									l_d := l_d + 1
									l_tmp_3 := l_s
									l_s := l_s + 1
									l_tmp_2.item := (((l_tmp_3.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
									l_n := l_n - 1
									if not l_n.to_boolean then
										l_break := True
									end
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_new_wsize := l_new_wsize + 1
							from
							until
								(l_break)
							loop
								l_break := False
								asm1 (l_ptr_dummy, l_wp)
								l_break := True
							end
							l_break := False
							l_wsize_signed := -l_wsize_signed
						end
					else
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_d_0 := l_wp.item
							l_s_0 := l_wp.item
							l_n_0 := l_wsize.item
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp_4 := l_d_0
								l_d_0 := l_d_0 + 1
								l_tmp_5 := l_s_0
								l_s_0 := l_s_0 + 1
								l_tmp_4.item := (((l_tmp_5.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
								l_n_0 := l_n_0 - 1
								if not l_n_0.to_boolean then
									l_break := True
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_cy := l_cy + ((create {P_GMP_STATIC}).gmpn_add_1 (l_wp.item, l_wp.item, l_wsize.item, (1).to_natural_32))
						l_cy := l_cy - 1
						l_cy2_0 := (l_cy = {NATURAL_32} 4_294_967_295).to_integer.to_natural_32
						l_cy := l_cy + l_cy2_0
						from
						until
							(l_break)
						loop
							l_break := False
							l_cy3 := (create {P_GMP_STATIC}).gmpn_mul_1 (l_wp.item + l_wsize.item, l_xp + l_wsize.item, l_xsize - l_wsize.item, a_y)
							l_cy := l_cy3 + ((create {P_GMP_STATIC}).gmpn_add_1 (l_wp.item + l_wsize.item, (l_wp.item + l_wsize.item), l_xsize - l_wsize.item, l_cy))
							l_break := True
						end
						l_break := False
						l_wp.item[l_new_wsize] := l_cy
						l_new_wsize := l_new_wsize + (l_cy /= {NATURAL_32} 0).to_integer
						if l_cy2_0.to_boolean then
							from
							until
								(l_break)
							loop
								l_break := False
								asm2 (l_ptr_dummy_0, l_wp, l_wsize)
								l_break := True
							end
							l_break := False
						end
						l_wsize_signed := -l_wsize_signed
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_new_wsize > 0))
						loop
							l_break := False
							if l_wp.item[(l_new_wsize - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_return or l_break) then
								l_new_wsize := l_new_wsize - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				if l_wsize_signed >= 0 then
					a_w.item.mp_size := l_new_wsize.to_integer_32
				else
					a_w.item.mp_size := (-l_new_wsize).to_integer_32
				end
			end
		end

	gmpz_addmul_ui (a_w, a_x: CE_POINTER [PD_MPZ_STRUCT]; a_y: NATURAL_32)
		do
			gmpz_aorsmul_1 ((0).to_integer_32, a_w, a_x, a_y)
		end

	gmpz_submul_ui (a_w, a_x: CE_POINTER [PD_MPZ_STRUCT]; a_y: NATURAL_32)
		do
			gmpz_aorsmul_1 ((-1).to_integer_32, a_w, a_x, (a_y).bit_and ({NATURAL_32} 4_294_967_295))
		end

end
