class
	P_CDIV_Q_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_cdiv_q (a_quot, a_dividend, a_divisor: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_dividend_size: INTEGER_32
			l_divisor_size: INTEGER_32
			l_rem: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_1: INTEGER_32
			l_tmp_3: INTEGER_32
			l_tmp_5: CE_POINTER [ANY]
			l_tmp_6: INTEGER_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_rem.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_dividend_size := (a_dividend.item.mp_size).to_integer_32
			l_divisor_size := (a_divisor.item.mp_size).to_integer_32
			l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_x := l_rem
				if l_divisor_size >= 0 then
					l_x.item.mp_alloc := l_divisor_size.to_integer_32
				else
					l_x.item.mp_alloc := (-l_divisor_size).to_integer_32
				end
				if l_divisor_size >= 0 then
					l_tmp_6 := l_divisor_size
				else
					l_tmp_6 := -l_divisor_size
				end
				if (builtin_expect ((l_tmp_6.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					if l_divisor_size >= 0 then
						l_tmp_1 := l_divisor_size
					else
						l_tmp_1 := -l_divisor_size
					end
					l_tmp_5 := (l_aaf.new ((l_tmp_1.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					if l_divisor_size >= 0 then
						l_tmp_3 := l_divisor_size
					else
						l_tmp_3 := -l_divisor_size
					end
					l_tmp_5 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_tmp_3.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_5)
				l_break := True
			end
			l_break := False;
			(create {P_TDIV_QR_STATIC}).gmpz_tdiv_qr (a_quot, l_rem, a_dividend, a_divisor)
			if ((l_divisor_size).bit_xor (l_dividend_size)) >= 0 then
				if l_rem[0].mp_size /= 0 then
					(create {P_AORS_UI_STATIC}).gmpz_add_ui (a_quot, a_quot, {NATURAL_32} 1)
				end
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
				end
				l_break := True
			end
			l_break := False
		end

end
