class
	P_CDIV_Q_UI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBMPZ_ASSEMBLER

feature {ANY} -- public routines

	gmpz_cdiv_q_ui (a_quot, a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: NATURAL_32): NATURAL_32
		local
			l_ns: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_np: CE_POINTER [NATURAL_32]
			l_qp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rl: NATURAL_32
			l_ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_qp.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_ptr_dummy.make (<<1>>)

			if a_divisor = {NATURAL_32} 0 then
				(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
			end
			l_ns := (a_dividend.item.mp_size).to_integer_32
			if l_ns = 0 then
				a_quot.item.mp_size := 0
				Result := {NATURAL_32} 0
				l_return := True
			end
			if not l_return then
				if l_ns >= 0 then
					l_nn := l_ns
				else
					l_nn := -l_ns
				end
				if (builtin_expect ((l_nn > (a_quot.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_quot, l_nn).do_nothing
				end
				l_qp.item := a_quot.item.mp_d
				l_np := a_dividend.item.mp_d
				l_rl := (create {P_GMP_STATIC}).gmpn_divrem_1 (l_qp.item, (0).to_integer_32, l_np, l_nn, a_divisor)
				if l_rl /= {NATURAL_32} 0 then
					if l_ns >= 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							asm5 (l_ptr_dummy, l_qp)
							l_break := True
						end
						l_break := False
						l_rl := a_divisor - l_rl
					end
				end
				l_qn := l_nn - (l_qp.item[(l_nn - 1)] = {NATURAL_32} 0).to_integer
				if l_ns >= 0 then
					a_quot.item.mp_size := l_qn.to_integer_32
				else
					a_quot.item.mp_size := (-l_qn).to_integer_32
				end
				Result := l_rl
			end
		end

end
