class
	P_COM_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_com (a_dst, a_src: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_size: INTEGER_32
			l_src_ptr: CE_POINTER [NATURAL_32]
			l_dst_ptr: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_return: BOOLEAN
		do
			l_size := (a_src.item.mp_size).to_integer_32
			if l_size >= 0 then
				if (a_dst.item.mp_alloc).to_integer_32 < l_size + 1 then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_dst, l_size + 1).do_nothing
				end
				l_src_ptr := a_src.item.mp_d
				l_dst_ptr := a_dst.item.mp_d
				if (builtin_expect ((l_size = 0).to_integer, 0)).to_boolean then
					l_dst_ptr[0] := (1).to_natural_32
					a_dst.item.mp_size := -1
					l_return := True
				end
				if not l_return then
					l_cy := (create {P_GMP_STATIC}).gmpn_add_1 (l_dst_ptr, l_src_ptr, l_size, (1).to_natural_32)
					if l_cy.to_boolean then
						l_dst_ptr[l_size] := l_cy
						l_size := l_size + 1
					end
					a_dst.item.mp_size := (-l_size).to_integer_32
				end
			else
				l_size := -l_size
				if (a_dst.item.mp_alloc).to_integer_32 < l_size then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_dst, l_size).do_nothing
				end
				l_src_ptr := a_src.item.mp_d
				l_dst_ptr := a_dst.item.mp_d;
				(create {P_GMP_STATIC}).gmpn_sub_1 (l_dst_ptr, l_src_ptr, l_size, (1).to_natural_32).do_nothing
				l_size := l_size - (l_dst_ptr[(l_size - 1)] = {NATURAL_32} 0).to_integer
				a_dst.item.mp_size := l_size.to_integer_32
			end
			if not l_return then
			end
		end

end
