class
	P_COMBIT_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_combit (a_d: CE_POINTER [PD_MPZ_STRUCT]; a_bit_index: NATURAL_32)
		local
			l_dsize: INTEGER_32
			l_tmp: INTEGER_32
			l_dp: CE_POINTER [NATURAL_32]
			l_limb_index: INTEGER_32
			l_bit: NATURAL_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp_1: CE_POINTER [NATURAL_32]
			l_x: NATURAL_32
			l_i: INTEGER_32
			l_c: NATURAL_32
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_r: NATURAL_32
			l_gmp_j: INTEGER_32
			l_gmp_j_0: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if a_d.item.mp_size >= 0 then
				l_tmp := a_d.item.mp_size
			else
				l_tmp := -a_d.item.mp_size
			end
			l_dsize := l_tmp.to_integer_32
			l_dp := a_d.item.mp_d
			l_limb_index := (a_bit_index // {NATURAL_32} 32).to_integer_32
			l_bit := ({NATURAL_32} 1).bit_shift_left ((a_bit_index \\ {NATURAL_32} 32).to_integer_32)
			if l_limb_index >= l_dsize then
				if (builtin_expect ((l_limb_index + 1 > (a_d.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_d, l_limb_index + 1).do_nothing
				end
				l_dp := a_d.item.mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if (l_limb_index + 1) - l_dsize /= 0 then
						l_dst := l_dp + l_dsize
						l_n := (l_limb_index + 1) - l_dsize
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp_1 := l_dst
							l_dst := l_dst + 1
							l_tmp_1.item := (0).to_natural_32
							l_n := l_n - 1
							if not l_n.to_boolean then
								l_break := True
							end
						end
						l_break := False
					end
					l_break := True
				end
				l_break := False
				l_dsize := l_limb_index + 1
			end
			if a_d.item.mp_size >= 0 then
				l_dp[l_limb_index] := (l_dp[l_limb_index]).bit_xor (l_bit)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_dsize > 0))
					loop
						l_break := False
						if l_dp[(l_dsize - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_dsize := l_dsize - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				a_d.item.mp_size := l_dsize.to_integer_32
			else
				l_x := (-(l_dp[l_limb_index]).to_integer_32).to_natural_32
				l_i := l_limb_index - 1
				from
				until
					not (not (l_break) and then (l_i >= 0))
				loop
					l_break := False
					if l_dp[l_i] /= {NATURAL_32} 0 then
						l_x := l_x - 1
						l_break := True
					end
					if not (l_return or l_break) then
						l_i := l_i - 1
					end
				end
				l_break := False
				if ((l_x).bit_and (l_bit)).to_boolean then
					if (builtin_expect ((l_dsize + 1 > (a_d.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_d, l_dsize + 1).do_nothing
					end
					l_dp := a_d.item.mp_d
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_gmp_x := (l_dp + l_limb_index)[0]
						l_gmp_r := l_gmp_x + l_bit;
						(l_dp + l_limb_index)[0] := l_gmp_r
						if l_gmp_r < l_bit then
							l_c := (1).to_natural_32
							l_gmp_i := (1).to_integer_32
							from
							until
								not (not (l_return or l_break) and then (l_gmp_i < l_dsize - l_limb_index))
							loop
								l_break := False
								l_gmp_x := (l_dp + l_limb_index)[l_gmp_i]
								l_gmp_r := l_gmp_x + {NATURAL_32} 1;
								(l_dp + l_limb_index)[l_gmp_i] := l_gmp_r
								l_gmp_i := l_gmp_i + 1
								if not (l_gmp_r < {NATURAL_32} 1) then
									if not (l_dp + l_limb_index).is_equal (l_dp + l_limb_index) then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											l_gmp_j := l_gmp_i
											from
											until
												not (l_gmp_j < l_dsize - l_limb_index)
											loop
												(l_dp + l_limb_index)[l_gmp_j] := (l_dp + l_limb_index)[l_gmp_j]
												l_gmp_j := l_gmp_j + 1
											end
											l_break := True
										end
										l_break := False
									end
									l_c := (0).to_natural_32
									l_break := True
								end
							end
							l_break := False
						else
							if not (l_dp + l_limb_index).is_equal (l_dp + l_limb_index) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_gmp_j_0 := (1).to_integer_32
									from
									until
										not (l_gmp_j_0 < l_dsize - l_limb_index)
									loop
										(l_dp + l_limb_index)[l_gmp_j_0] := (l_dp + l_limb_index)[l_gmp_j_0]
										l_gmp_j_0 := l_gmp_j_0 + 1
									end
									l_break := True
								end
								l_break := False
							end
							l_c := (0).to_natural_32
						end
						l_break := True
					end
					l_break := False
					l_dp[l_dsize] := l_c
					l_dsize := (l_dsize.to_natural_32 + l_c).to_integer_32
				else
					(create {P_GMP_STATIC}).gmpn_sub_1 (l_dp + l_limb_index, (l_dp + l_limb_index), l_dsize + l_limb_index, l_bit).do_nothing
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_dsize > 0))
					loop
						l_break := False
						if l_dp[(l_dsize - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_dsize := l_dsize - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				a_d.item.mp_size := (-l_dsize).to_integer_32
			end
		end

end
