class
	P_DIVEGCD_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	mpz_divexact_by3 (a_q, a_a: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp_1: NATURAL_32
			l_return: BOOLEAN
		do
			l_size := (a_a.item.mp_size).to_integer_32
			if l_size = 0 then
				a_q.item.mp_size := 0
				l_return := True
			else
				if l_size >= 0 then
					l_tmp := l_size
				else
					l_tmp := -l_size
				end
				l_abs_size := l_tmp
				if (builtin_expect ((l_abs_size > (a_q.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_q, l_abs_size).do_nothing
				end
				l_qp := a_q.item.mp_d
				l_tmp_1 := (create {P_GMP_IMPL_STATIC}).gmpn_bdiv_dbm1c (l_qp, a_a.item.mp_d, l_abs_size, {NATURAL_32} 1_431_655_765, (0).to_natural_32)
				l_abs_size := l_abs_size - (l_qp[(l_abs_size - 1)] = {NATURAL_32} 0).to_integer
				if l_size > 0 then
					a_q.item.mp_size := l_abs_size.to_integer_32
				else
					a_q.item.mp_size := (-l_abs_size).to_integer_32
				end
			end
			if not l_return then
			end
		end

	gmpz_divexact_gcd (a_q, a_a, a_d: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_dl: NATURAL_32
			l_twos: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if a_d.item.mp_size = 1 then
				l_dl := a_d.item.mp_d[0]
				if l_dl = {NATURAL_32} 1 then
					if not a_q.is_equal (a_a) then
						(create {P_SET_STATIC}).gmpz_set (a_q, a_a)
					end
					l_return := True
				end
				if not l_return and then (l_dl = {NATURAL_32} 3) then
					mpz_divexact_by3 (a_q, a_a)
					l_return := True
				end
				if not l_return then
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_twos := builtin_ctzl (l_dl)
						l_break := True
					end
					l_break := False
					l_dl := (l_dl).bit_shift_right (l_twos)
					if l_dl = {NATURAL_32} 1 then
						(create {P_TDIV_Q_2EXP_STATIC}).gmpz_tdiv_q_2exp (a_q, a_a, l_twos.to_natural_32)
						l_return := True
					end
				end
				if not l_return and then (l_dl = {NATURAL_32} 3) then
					(create {P_TDIV_Q_2EXP_STATIC}).gmpz_tdiv_q_2exp (a_q, a_a, l_twos.to_natural_32)
					mpz_divexact_by3 (a_q, a_q)
					l_return := True
				end
			end
			if not l_return then
				(create {P_DIVEXACT_STATIC}).gmpz_divexact (a_q, a_a, a_d)
			end
		end

end
