class
	P_FAC_UI_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBMPZ_ASSEMBLER

feature {ANY} -- public attributes

	table: CE_STATIC [CE_ARRAY [NATURAL_32]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_32_ARRAY}.make_initialized (<<
					1, 1, 2, 6, 24, 120, 720, 5_040, 40_320, 362_880, 3_628_800, 39_916_800, 479_001_600
				>>)
		end

feature {ANY} -- public routines

	gmpz_fac_ui (a_x: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		local
			l_n: CE_ARRAY [NATURAL_32]
			l_z: CE_ARRAY [NATURAL_32]
			l_stt: NATURAL_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_t1: CE_ARRAY [PD_MPZ_STRUCT]
			l_st: CE_ARRAY [CE_ARRAY [PD_MPZ_STRUCT]]
			l_d: CE_ARRAY [CE_ARRAY [NATURAL_32]]
			l_z2: CE_POINTER [PD_MPZ_STRUCT]
			l_z_0: CE_POINTER [PD_MPZ_STRUCT]
			l_x: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_n.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_z.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_t1.make (<<1>>)
			create {CE_ARRAY_ARRAY [PD_MPZ_STRUCT]} l_st.make (<<(({NATURAL_32} 8 * {PLATFORM}.Natural_32_bytes.to_natural_32 + {NATURAL_32} 1) - {NATURAL_32} 5).to_integer_32, 1>>)
			create {CE_ARRAY_ARRAY [NATURAL_32]} l_d.make (<<1, 4>>)

			l_n.item := a_n
			if l_n.item < (({PLATFORM}.Natural_32_bytes.to_natural_32 * (13).to_natural_32) // {PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_z2 := a_x
					l_z2.item.mp_d[0] := table.item[(l_n.item).to_integer_32]
					l_z2.item.mp_size := 1
					l_break := True
				end
				l_break := False
				l_return := True
			end
			if not l_return then
				asm10 (l_d, l_n)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_z.item := (builtin_clzl (l_d.item[1])).to_natural_32
					l_break := True
				end
				l_break := False
				l_z.item := ({NATURAL_32} 32 - l_z.item) - {NATURAL_32} 1
				asm11 (l_d, l_n, l_z)
				l_d.item[0] := (((l_d.item[0]).bit_shift_right (2))).bit_or (((l_d.item[1]).bit_shift_left (30)))
				l_d.item[1] := (l_d.item[1]).bit_shift_right ((2))
				l_z.item := l_d.item[0] + {NATURAL_32} 1
				if l_n.item <= ({NATURAL_32} 1).bit_shift_left (5) then
					(create {P_REALLOC2_STATIC}).gmpz_realloc2 (a_x, {NATURAL_32} 4 * l_z.item)
					ap_product_small (a_x, (2).to_natural_32, (1).to_natural_32, l_n.item - {NATURAL_32} 1, {NATURAL_32} 4)
					l_return := True
				end
			end
			if not l_return and then (l_n.item <= ({NATURAL_32} 1).bit_shift_left (6)) then
				(create {P_INIT2_STATIC}).gmpz_init2 (l_t1, {NATURAL_32} 2 * l_z.item);
				(create {P_REALLOC2_STATIC}).gmpz_realloc2 (a_x, {NATURAL_32} 4 * l_z.item)
				ap_product_small (a_x, (2).to_natural_32, (1).to_natural_32, l_n.item // {NATURAL_32} 2 - {NATURAL_32} 1, {NATURAL_32} 4)
				ap_product_small (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1), (3).to_natural_32, (2).to_natural_32, (l_n.item - {NATURAL_32} 1) // {NATURAL_32} 2, {NATURAL_32} 4);
				(create {P_MUL_STATIC}).gmpz_mul (a_x, a_x, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1));
				(create {P_CLEAR_STATIC}).gmpz_clear (l_t1);
				(create {P_MUL_2EXP_STATIC}).gmpz_mul_2exp (a_x, a_x, l_n.item // {NATURAL_32} 2)
				l_return := True
			end
			if not l_return and then (l_n.item <= ({NATURAL_32} 1).bit_shift_left (7)) then
				(create {P_INIT2_STATIC}).gmpz_init2 (l_t1, {NATURAL_32} 2 * l_z.item);
				(create {P_REALLOC2_STATIC}).gmpz_realloc2 (a_x, {NATURAL_32} 4 * l_z.item)
				l_i := 0
				from
				until
					not (l_i < 4)
				loop
					(create {P_INIT2_STATIC}).gmpz_init2 (l_st[l_i], l_z.item)
					l_z.item := (l_z.item).bit_shift_right ((1))
					l_i := l_i + 1
				end
				odd_product ({NATURAL_32} 1, l_n.item // {NATURAL_32} 2, l_st);
				(create {P_SET_STATIC}).gmpz_set (a_x, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_st[0])))
				odd_product (l_n.item // {NATURAL_32} 2, l_n.item, l_st);
				(create {P_MUL_STATIC}).gmpz_mul (a_x, a_x, a_x)
				ap_product_small (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1), (2).to_natural_32, (1).to_natural_32, l_n.item // {NATURAL_32} 4 - {NATURAL_32} 1, {NATURAL_32} 4);
				(create {P_MUL_STATIC}).gmpz_mul (l_t1, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_st[0])))
				l_i := 0
				from
				until
					not (l_i < 4)
				loop
					(create {P_CLEAR_STATIC}).gmpz_clear (l_st[l_i])
					l_i := l_i + 1
				end
				(create {P_MUL_STATIC}).gmpz_mul (a_x, a_x, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1));
				(create {P_CLEAR_STATIC}).gmpz_clear (l_t1);
				(create {P_MUL_2EXP_STATIC}).gmpz_mul_2exp (a_x, a_x, l_n.item // {NATURAL_32} 2 + l_n.item // {NATURAL_32} 4)
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_stt := (builtin_clzl (l_n.item)).to_natural_32
					l_break := True
				end
				l_break := False
				l_stt := (({NATURAL_32} 32 - l_stt) + {NATURAL_32} 1) - {NATURAL_32} 5
				l_i := 0
				from
				until
					not (l_i.to_integer_32 < l_stt.to_integer_32)
				loop
					(create {P_INIT2_STATIC}).gmpz_init2 (l_st[l_i], l_z.item)
					l_z.item := (l_z.item).bit_shift_right ((1))
					l_i := l_i + 1
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_z.item := (builtin_clzl (l_n.item // {NATURAL_32} 3)).to_natural_32
					l_break := True
				end
				l_break := False
				l_z.item := {NATURAL_32} 32 - l_z.item;
				(create {P_ISET_UI_STATIC}).gmpz_init_set_ui (l_t1, {NATURAL_32} 1)
				l_j := (({NATURAL_32} 8 * {PLATFORM}.Natural_32_bytes.to_natural_32) // {NATURAL_32} 2).to_integer_32
				from
				until
					not (not (l_return) and then (l_j /= 0))
				loop
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_z_0 := a_x
						l_z_0.item.mp_d[0] := (1).to_natural_32
						l_z_0.item.mp_size := 1
						l_break := True
					end
					l_break := False
					l_i := ({NATURAL_32} 8 * {PLATFORM}.Natural_32_bytes.to_natural_32 - l_j.to_natural_32).to_integer_32
					from
					until
						not (l_i >= l_j)
					loop
						if (l_z.item).to_integer_32 >= l_i.to_integer_32 then
							odd_product ((l_n.item).bit_shift_right (l_i), (l_n.item).bit_shift_right ((l_i - 1)), l_st)
							if l_i /= l_j then
								(create {P_POW_UI_STATIC}).gmpz_pow_ui (l_st[0], create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_st[0])), (l_i // l_j).to_natural_32)
							end
							(create {P_MUL_STATIC}).gmpz_mul (a_x, a_x, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_st[0])))
						end
						l_i := l_i - (2 * l_j)
					end
					if (l_z.item).to_integer_32 >= l_j.to_integer_32 then
						if l_j /= 1 then
							(create {P_MUL_STATIC}).gmpz_mul (l_t1, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1), a_x);
							(create {P_MUL_STATIC}).gmpz_mul (l_t1, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1))
						end
					end
					l_j := (l_j).bit_shift_right ((1))
				end
				l_i := 0
				from
				until
					not (l_i.to_integer_32 < l_stt.to_integer_32)
				loop
					(create {P_CLEAR_STATIC}).gmpz_clear (l_st[l_i])
					l_i := l_i + 1
				end
				(create {P_MUL_STATIC}).gmpz_mul (a_x, a_x, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t1));
				(create {P_CLEAR_STATIC}).gmpz_clear (l_t1)
				from
				until
					(l_break)
				loop
					l_break := False
					l_x := l_n.item
					l_x := l_x - ((((l_x).bit_shift_right (1))).bit_and ({NATURAL_32} 1_431_655_765))
					l_x := ((((l_x).bit_shift_right (2))).bit_and ({NATURAL_32} 858_993_459)) + ((l_x).bit_and ({NATURAL_32} 858_993_459))
					l_x := ((((l_x).bit_shift_right (4)) + l_x)).bit_and ({NATURAL_32} 252_645_135)
					l_x := ((l_x).bit_shift_right (8)) + l_x
					l_x := ((l_x).bit_shift_right (16)) + l_x
					l_i := ((l_x).bit_and ({NATURAL_32} 255)).to_integer_32
					l_break := True
				end
				l_break := False;
				(create {P_MUL_2EXP_STATIC}).gmpz_mul_2exp (a_x, a_x, l_n.item - l_i.to_natural_32)
			end
		end

	ap_product_small (a_ret: CE_POINTER [PD_MPZ_STRUCT]; a_start, a_step, a_count, a_nm: NATURAL_32)
		local
			l_a: NATURAL_32
			l_b: NATURAL_32
			l_z: CE_POINTER [PD_MPZ_STRUCT]
			l_z_0: CE_POINTER [PD_MPZ_STRUCT]
			l_z_1: CE_POINTER [PD_MPZ_STRUCT]
			l_dst: CE_POINTER [PD_MPZ_STRUCT]
			l_src: CE_POINTER [PD_MPZ_STRUCT]
			l_size: INTEGER_32
			l_dst_p: CE_POINTER [NATURAL_32]
			l_c: NATURAL_32
			l_z_2: CE_POINTER [PD_MPZ_STRUCT]
			l_dst_0: CE_POINTER [PD_MPZ_STRUCT]
			l_src_0: CE_POINTER [PD_MPZ_STRUCT]
			l_size_0: INTEGER_32
			l_dst_p_0: CE_POINTER [NATURAL_32]
			l_c_0: NATURAL_32
			l_dst_1: CE_POINTER [PD_MPZ_STRUCT]
			l_src_1: CE_POINTER [PD_MPZ_STRUCT]
			l_size_1: INTEGER_32
			l_dst_p_1: CE_POINTER [NATURAL_32]
			l_c_1: NATURAL_32
			l_z_3: CE_POINTER [PD_MPZ_STRUCT]
			l_z_4: CE_POINTER [PD_MPZ_STRUCT]
			l_dst_2: CE_POINTER [PD_MPZ_STRUCT]
			l_src_2: CE_POINTER [PD_MPZ_STRUCT]
			l_size_2: INTEGER_32
			l_dst_p_2: CE_POINTER [NATURAL_32]
			l_c_2: NATURAL_32
			l_dst_3: CE_POINTER [PD_MPZ_STRUCT]
			l_src_3: CE_POINTER [PD_MPZ_STRUCT]
			l_size_3: INTEGER_32
			l_dst_p_3: CE_POINTER [NATURAL_32]
			l_c_3: NATURAL_32
			l_z_5: CE_POINTER [PD_MPZ_STRUCT]
			l_z_6: CE_POINTER [PD_MPZ_STRUCT]
			l_z_7: CE_POINTER [PD_MPZ_STRUCT]
			l_dst_4: CE_POINTER [PD_MPZ_STRUCT]
			l_src_4: CE_POINTER [PD_MPZ_STRUCT]
			l_size_4: INTEGER_32
			l_dst_p_4: CE_POINTER [NATURAL_32]
			l_c_4: NATURAL_32
			l_dst_5: CE_POINTER [PD_MPZ_STRUCT]
			l_src_5: CE_POINTER [PD_MPZ_STRUCT]
			l_size_5: INTEGER_32
			l_dst_p_5: CE_POINTER [NATURAL_32]
			l_c_5: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_count = {NATURAL_32} 0 then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_z := a_ret
							l_z.item.mp_d[0] := (1).to_natural_32
							l_z.item.mp_size := 1
							l_break := True
						end
						l_break := False
						l_return := True
					end
					if not l_return and then (a_count = {NATURAL_32} 1) then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_z_0 := a_ret
							l_z_0.item.mp_d[0] := a_start
							l_z_0.item.mp_size := 1
							l_break := True
						end
						l_break := False
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						inspect a_nm -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 1ul
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_z_1 := a_ret
							l_z_1.item.mp_d[0] := a_start
							l_z_1.item.mp_size := 1
							l_break := True
						end
						l_break := False
						l_b := a_start + a_step
						l_a := {NATURAL_32} 0
						from
						until
							not (not (l_return) and then (l_a < a_count - {NATURAL_32} 1))
						loop
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_dst := a_ret
								l_src := a_ret
								l_size := (l_src.item.mp_size).to_integer_32
								if (builtin_expect ((l_size + 1 > (l_dst.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
									(create {P_REALLOC_STATIC}).gmpz_realloc (l_dst, l_size + 1).do_nothing
								end
								l_dst_p := l_dst.item.mp_d
								l_c := (create {P_GMP_STATIC}).gmpn_mul_1 (l_dst_p, l_src.item.mp_d, l_size, l_b)
								l_dst_p[l_size] := l_c
								l_dst.item.mp_size := (l_size + (l_c /= {NATURAL_32} 0).to_integer).to_integer_32
								l_break := True
							end
							l_break := False
							l_b := l_b + a_step
							l_a := l_a + 1
						end
						l_return := True
				when 3 then -- switch 1, case 2ul
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_z_2 := a_ret
								l_z_2.item.mp_d[0] := a_start * (a_start + a_step)
								l_z_2.item.mp_size := 1
								l_break := True
							end
							l_break := False
							if a_count = {NATURAL_32} 2 then
								l_return := True
							end
						end
						if not l_return then
							l_b := a_start + {NATURAL_32} 2 * a_step
							l_a := a_count // {NATURAL_32} 2 - {NATURAL_32} 1
							from
							until
								not (not (l_return) and then (l_a /= {NATURAL_32} 0))
							loop
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_dst_0 := a_ret
									l_src_0 := a_ret
									l_size_0 := (l_src_0.item.mp_size).to_integer_32
									if (builtin_expect ((l_size_0 + 1 > (l_dst_0.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										(create {P_REALLOC_STATIC}).gmpz_realloc (l_dst_0, l_size_0 + 1).do_nothing
									end
									l_dst_p_0 := l_dst_0.item.mp_d
									l_c_0 := (create {P_GMP_STATIC}).gmpn_mul_1 (l_dst_p_0, l_src_0.item.mp_d, l_size_0, l_b * (l_b + a_step))
									l_dst_p_0[l_size_0] := l_c_0
									l_dst_0.item.mp_size := (l_size_0 + (l_c_0 /= {NATURAL_32} 0).to_integer).to_integer_32
									l_break := True
								end
								l_break := False
								l_a := l_a - 1
								l_b := l_b + ({NATURAL_32} 2 * a_step)
							end
							if a_count \\ {NATURAL_32} 2 = {NATURAL_32} 1 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_dst_1 := a_ret
									l_src_1 := a_ret
									l_size_1 := (l_src_1.item.mp_size).to_integer_32
									if (builtin_expect ((l_size_1 + 1 > (l_dst_1.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										(create {P_REALLOC_STATIC}).gmpz_realloc (l_dst_1, l_size_1 + 1).do_nothing
									end
									l_dst_p_1 := l_dst_1.item.mp_d
									l_c_1 := (create {P_GMP_STATIC}).gmpn_mul_1 (l_dst_p_1, l_src_1.item.mp_d, l_size_1, l_b)
									l_dst_p_1[l_size_1] := l_c_1
									l_dst_1.item.mp_size := (l_size_1 + (l_c_1 /= {NATURAL_32} 0).to_integer).to_integer_32
									l_break := True
								end
								l_break := False
							end
							l_return := True
						end
				when 4 then -- switch 1, case 3ul
						if not l_return and then (a_count = {NATURAL_32} 2) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_z_3 := a_ret
								l_z_3.item.mp_d[0] := a_start * (a_start + a_step)
								l_z_3.item.mp_size := 1
								l_break := True
							end
							l_break := False
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_z_4 := a_ret
								l_z_4.item.mp_d[0] := (a_start * (a_start + a_step)) * (a_start + {NATURAL_32} 2 * a_step)
								l_z_4.item.mp_size := 1
								l_break := True
							end
							l_break := False
							if a_count = {NATURAL_32} 3 then
								l_return := True
							end
						end
						if not l_return then
							l_b := a_start + {NATURAL_32} 3 * a_step
							l_a := a_count // {NATURAL_32} 3 - {NATURAL_32} 1
							from
							until
								not (not (l_return) and then (l_a /= {NATURAL_32} 0))
							loop
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_dst_2 := a_ret
									l_src_2 := a_ret
									l_size_2 := (l_src_2.item.mp_size).to_integer_32
									if (builtin_expect ((l_size_2 + 1 > (l_dst_2.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										(create {P_REALLOC_STATIC}).gmpz_realloc (l_dst_2, l_size_2 + 1).do_nothing
									end
									l_dst_p_2 := l_dst_2.item.mp_d
									l_c_2 := (create {P_GMP_STATIC}).gmpn_mul_1 (l_dst_p_2, l_src_2.item.mp_d, l_size_2, (l_b * (l_b + a_step)) * (l_b + {NATURAL_32} 2 * a_step))
									l_dst_p_2[l_size_2] := l_c_2
									l_dst_2.item.mp_size := (l_size_2 + (l_c_2 /= {NATURAL_32} 0).to_integer).to_integer_32
									l_break := True
								end
								l_break := False
								l_a := l_a - 1
								l_b := l_b + ({NATURAL_32} 3 * a_step)
							end
							if a_count \\ {NATURAL_32} 3 = {NATURAL_32} 2 then
								l_b := l_b * (l_b + a_step)
							end
							if a_count \\ {NATURAL_32} 3 /= {NATURAL_32} 0 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_dst_3 := a_ret
									l_src_3 := a_ret
									l_size_3 := (l_src_3.item.mp_size).to_integer_32
									if (builtin_expect ((l_size_3 + 1 > (l_dst_3.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										(create {P_REALLOC_STATIC}).gmpz_realloc (l_dst_3, l_size_3 + 1).do_nothing
									end
									l_dst_p_3 := l_dst_3.item.mp_d
									l_c_3 := (create {P_GMP_STATIC}).gmpn_mul_1 (l_dst_p_3, l_src_3.item.mp_d, l_size_3, l_b)
									l_dst_p_3[l_size_3] := l_c_3
									l_dst_3.item.mp_size := (l_size_3 + (l_c_3 /= {NATURAL_32} 0).to_integer).to_integer_32
									l_break := True
								end
								l_break := False
							end
							l_return := True
						end
				when 5 then -- switch 1, default:
						if not l_return and then (a_count = {NATURAL_32} 2) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_z_5 := a_ret
								l_z_5.item.mp_d[0] := a_start * (a_start + a_step)
								l_z_5.item.mp_size := 1
								l_break := True
							end
							l_break := False
							l_return := True
						end
						if not l_return and then (a_count = {NATURAL_32} 3) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_z_6 := a_ret
								l_z_6.item.mp_d[0] := (a_start * (a_start + a_step)) * (a_start + {NATURAL_32} 2 * a_step)
								l_z_6.item.mp_size := 1
								l_break := True
							end
							l_break := False
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_z_7 := a_ret
								l_z_7.item.mp_d[0] := ((a_start * (a_start + a_step)) * (a_start + {NATURAL_32} 2 * a_step)) * (a_start + {NATURAL_32} 3 * a_step)
								l_z_7.item.mp_size := 1
								l_break := True
							end
							l_break := False
							if a_count = {NATURAL_32} 4 then
								l_return := True
							end
						end
						if not l_return then
							l_b := a_start + {NATURAL_32} 4 * a_step
							l_a := a_count // {NATURAL_32} 4 - {NATURAL_32} 1
							from
							until
								not (not (l_return) and then (l_a /= {NATURAL_32} 0))
							loop
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_dst_4 := a_ret
									l_src_4 := a_ret
									l_size_4 := (l_src_4.item.mp_size).to_integer_32
									if (builtin_expect ((l_size_4 + 1 > (l_dst_4.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										(create {P_REALLOC_STATIC}).gmpz_realloc (l_dst_4, l_size_4 + 1).do_nothing
									end
									l_dst_p_4 := l_dst_4.item.mp_d
									l_c_4 := (create {P_GMP_STATIC}).gmpn_mul_1 (l_dst_p_4, l_src_4.item.mp_d, l_size_4, ((l_b * (l_b + a_step)) * (l_b + {NATURAL_32} 2 * a_step)) * (l_b + {NATURAL_32} 3 * a_step))
									l_dst_p_4[l_size_4] := l_c_4
									l_dst_4.item.mp_size := (l_size_4 + (l_c_4 /= {NATURAL_32} 0).to_integer).to_integer_32
									l_break := True
								end
								l_break := False
								l_a := l_a - 1
								l_b := l_b + ({NATURAL_32} 4 * a_step)
							end
							if a_count \\ {NATURAL_32} 4 = {NATURAL_32} 2 then
								l_b := l_b * (l_b + a_step)
							end
							if a_count \\ {NATURAL_32} 4 = {NATURAL_32} 3 then
								l_b := (l_b * (l_b + a_step)) * (l_b + {NATURAL_32} 2 * a_step)
							end
							if a_count \\ {NATURAL_32} 4 /= {NATURAL_32} 0 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_dst_5 := a_ret
									l_src_5 := a_ret
									l_size_5 := (l_src_5.item.mp_size).to_integer_32
									if (builtin_expect ((l_size_5 + 1 > (l_dst_5.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
										(create {P_REALLOC_STATIC}).gmpz_realloc (l_dst_5, l_size_5 + 1).do_nothing
									end
									l_dst_p_5 := l_dst_5.item.mp_d
									l_c_5 := (create {P_GMP_STATIC}).gmpn_mul_1 (l_dst_p_5, l_src_5.item.mp_d, l_size_5, l_b)
									l_dst_p_5[l_size_5] := l_c_5
									l_dst_5.item.mp_size := (l_size_5 + (l_c_5 /= {NATURAL_32} 0).to_integer).to_integer_32
									l_break := True
								end
								l_break := False
							end
						end
				when 6 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	odd_product (a_low, a_high: NATURAL_32; a_st: CE_POINTER [CE_ARRAY [PD_MPZ_STRUCT]])
		local
			l_low: NATURAL_32
			l_high: NATURAL_32
			l_stc: NATURAL_32
			l_stn: NATURAL_32
			l_n: NATURAL_32
			l_y: NATURAL_32
			l_mask: NATURAL_32
			l_a: NATURAL_32
			l_nm: NATURAL_32
			l_z: CE_ARRAY [INTEGER_32]
			l_z2: CE_POINTER [PD_MPZ_STRUCT]
			l_z_0: CE_POINTER [PD_MPZ_STRUCT]
			l_dst: CE_ARRAY [NATURAL_32]
			l_tmp_0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_z.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_dst.make (<<1>>)

			l_low := a_low
			l_high := a_high
			l_stc := {NATURAL_32} 1
			l_stn := {NATURAL_32} 0
			l_nm := {NATURAL_32} 1
			l_low := l_low + 1
			if l_low \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
				l_low := l_low + 1
			end
			if l_high = {NATURAL_32} 0 then
				l_high := {NATURAL_32} 1
			end
			if l_high \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
				l_high := l_high - 1
			end
			if l_high < l_low then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_z2 := a_st[0]
					l_z2.item.mp_d[0] := (1).to_natural_32
					l_z2.item.mp_size := 1
					l_break := True
				end
				l_break := False
				l_return := True
			end
			if not l_return and then (l_high = l_low) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_z_0 := a_st[0]
					l_z_0.item.mp_d[0] := l_low
					l_z_0.item.mp_size := 1
					l_break := True
				end
				l_break := False
				l_return := True
			end
			if not l_return then
				if l_high <= {NATURAL_32} 65_537 then
					l_nm := {NATURAL_32} 2
					if l_high <= {NATURAL_32} 1_627 then
						l_nm := {NATURAL_32} 3
						if l_high <= {NATURAL_32} 259 then
							l_nm := {NATURAL_32} 4
						end
					end
				end
				l_high := (l_high - l_low) // {NATURAL_32} 2 + {NATURAL_32} 1
				if l_high <= ({NATURAL_32} 1).bit_shift_left (5) then
					ap_product_small (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((a_st[0])), l_low, (2).to_natural_32, l_high, l_nm)
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_n := (builtin_clzl (l_high)).to_natural_32
					l_break := True
				end
				l_break := False
				l_n := ({NATURAL_32} 32 - l_n) - {NATURAL_32} 5
				l_mask := ({NATURAL_32} 1).bit_shift_left (l_n.to_integer_32)
				l_a := (l_mask).bit_shift_left (1)
				l_mask := l_mask - 1
				l_z.item := l_mask.to_integer_32
				from
				until
					not (not (l_return) and then (l_z.item >= 0))
				loop
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							asm12 (l_dst, l_z)
							l_break := True
						end
						l_break := False
						l_dst.item := (((((l_dst.item).bit_shift_right (4))).bit_and ({NATURAL_32} 252_645_135))).bit_or (((((l_dst.item).bit_shift_left (4))).bit_and ({NATURAL_32} 4_042_322_160)))
						l_dst.item := (((((l_dst.item).bit_shift_right (2))).bit_and ({NATURAL_32} 858_993_459))).bit_or (((((l_dst.item).bit_shift_left (2))).bit_and ({NATURAL_32} 3_435_973_836)))
						l_dst.item := (((((l_dst.item).bit_shift_right (1))).bit_and ({NATURAL_32} 1_431_655_765))).bit_or (((((l_dst.item).bit_shift_left (1))).bit_and ({NATURAL_32} 2_863_311_530)))
						l_y := l_dst.item
						l_break := True
					end
					l_break := False
					l_y := (l_y).bit_shift_right (({NATURAL_32} 32 - l_n).to_integer_32)
					ap_product_small (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((a_st[l_stn.to_integer_32])), l_low + {NATURAL_32} 2 * (((l_y).bit_not).bit_and (l_mask)), l_a, ((l_high + l_y)).bit_shift_right (l_n.to_integer_32), l_nm)
					l_stn := l_stn + 1
					l_tmp_0 := l_stc
					l_stc := l_stc + 1
					l_y := l_tmp_0
					from
					until
						((l_y).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0
					loop
						(create {P_MUL_STATIC}).gmpz_mul (a_st[(l_stn - {NATURAL_32} 2).to_integer_32], create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((a_st[(l_stn - {NATURAL_32} 2).to_integer_32])), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast ((a_st[(l_stn - {NATURAL_32} 1).to_integer_32])))
						l_stn := l_stn - 1
						l_y := (l_y).bit_shift_right ((1))
					end
					l_z.item := l_z.item - 1
				end
			end
		end

end
