class
	P_GCD_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_gcd (a_g, a_u, a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_g_zero_bits: NATURAL_32
			l_u_zero_bits: NATURAL_32
			l_v_zero_bits: NATURAL_32
			l_g_zero_limbs: INTEGER_32
			l_u_zero_limbs: INTEGER_32
			l_v_zero_limbs: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_tmp: INTEGER_32
			l_vp: CE_POINTER [NATURAL_32]
			l_vsize: INTEGER_32
			l_tmp_0: INTEGER_32
			l_gsize: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp_5: CE_POINTER [ANY]
			l_tmp_11: CE_POINTER [ANY]
			l_tmp_13: INTEGER_32
			l_tmp_14: INTEGER_32
			l_cy_limb: NATURAL_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp_15: CE_POINTER [NATURAL_32]
			l_dst_0: CE_POINTER [NATURAL_32]
			l_n_0: INTEGER_32
			l_tmp_16: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_up := a_u.item.mp_d
			if a_u.item.mp_size >= 0 then
				l_tmp := a_u.item.mp_size
			else
				l_tmp := -a_u.item.mp_size
			end
			l_usize := l_tmp.to_integer_32
			l_vp := a_v.item.mp_d
			if a_v.item.mp_size >= 0 then
				l_tmp_0 := a_v.item.mp_size
			else
				l_tmp_0 := -a_v.item.mp_size
			end
			l_vsize := l_tmp_0.to_integer_32
			if l_usize = 0 then
				a_g.item.mp_size := l_vsize.to_integer_32
				if a_g.is_equal (a_v) then
					l_return := True
				end
				if not l_return then
					if (a_g.item.mp_alloc).to_integer_32 < l_vsize then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_g, l_vsize).do_nothing
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (a_g.item.mp_d, l_vp, l_vsize)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_return := True
				end
			end
			if not l_return and then (l_vsize = 0) then
				a_g.item.mp_size := l_usize.to_integer_32
				if a_g.is_equal (a_u) then
					l_return := True
				end
				if not l_return then
					if (a_g.item.mp_alloc).to_integer_32 < l_usize then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_g, l_usize).do_nothing
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (a_g.item.mp_d, l_up, l_usize)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_return := True
				end
			end
			if not l_return and then (l_usize = 1) then
				a_g.item.mp_size := 1
				a_g.item.mp_d[0] := (create {P_GMP_STATIC}).gmpn_gcd_1 (l_vp, l_vsize, l_up[0])
				l_return := True
			end
			if not l_return and then (l_vsize = 1) then
				a_g.item.mp_size := 1
				a_g.item.mp_d[0] := (create {P_GMP_STATIC}).gmpn_gcd_1 (l_up, l_usize, l_vp[0])
				l_return := True
			end
			if not l_return then
				l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				from
				until
					l_up.item /= {NATURAL_32} 0
				loop
					l_up := l_up + 1
				end
				l_u_zero_limbs := (l_up.distance ((a_u.item.mp_d))).to_integer_32
				l_usize := l_usize - l_u_zero_limbs
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_u_zero_bits := (builtin_ctzl (l_up.item)).to_natural_32
					l_break := True
				end
				l_break := False
				l_tp := l_up
				if (builtin_expect ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_5 := (l_aaf.new ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp_5 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_up := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_5)
				if l_u_zero_bits /= {NATURAL_32} 0 then
					(create {P_GMP_STATIC}).gmpn_rshift (l_up, l_tp, l_usize, l_u_zero_bits.to_natural_32).do_nothing
					l_usize := l_usize - (l_up[(l_usize - 1)] = {NATURAL_32} 0).to_integer
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_up, l_tp, l_usize)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				from
				until
					l_vp.item /= {NATURAL_32} 0
				loop
					l_vp := l_vp + 1
				end
				l_v_zero_limbs := (l_vp.distance ((a_v.item.mp_d))).to_integer_32
				l_vsize := l_vsize - l_v_zero_limbs
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_v_zero_bits := (builtin_ctzl (l_vp.item)).to_natural_32
					l_break := True
				end
				l_break := False
				l_tp := l_vp
				if (builtin_expect ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_11 := (l_aaf.new ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp_11 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_vp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_11)
				if l_v_zero_bits /= {NATURAL_32} 0 then
					(create {P_GMP_STATIC}).gmpn_rshift (l_vp, l_tp, l_vsize, l_v_zero_bits.to_natural_32).do_nothing
					l_vsize := l_vsize - (l_vp[(l_vsize - 1)] = {NATURAL_32} 0).to_integer
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_vp, l_tp, l_vsize)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				if l_u_zero_limbs > l_v_zero_limbs then
					l_g_zero_limbs := l_v_zero_limbs
					l_g_zero_bits := l_v_zero_bits
				elseif l_u_zero_limbs < l_v_zero_limbs then
					l_g_zero_limbs := l_u_zero_limbs
					l_g_zero_bits := l_u_zero_bits
				else
					l_g_zero_limbs := l_u_zero_limbs
					if l_u_zero_bits < l_v_zero_bits then
						l_g_zero_bits := l_u_zero_bits
					else
						l_g_zero_bits := l_v_zero_bits
					end
				end
				if l_usize < l_vsize then
					l_tmp_13 := (create {P_GMP_STATIC}).gmpn_gcd (l_vp, l_vp, l_vsize, l_up, l_usize)
					l_vsize := l_tmp_13
				elseif l_usize = l_vsize then
					if l_up[(l_usize - 1)] < l_vp[(l_vsize - 1)] then
						l_tmp_13 := (create {P_GMP_STATIC}).gmpn_gcd (l_vp, l_vp, l_vsize, l_up, l_usize)
						l_vsize := l_tmp_13
					else
						l_tmp_14 := (create {P_GMP_STATIC}).gmpn_gcd (l_vp, l_up, l_usize, l_vp, l_vsize)
						l_vsize := l_tmp_14
					end
				else
					l_tmp_14 := (create {P_GMP_STATIC}).gmpn_gcd (l_vp, l_up, l_usize, l_vp, l_vsize)
					l_vsize := l_tmp_14
				end
				l_gsize := l_vsize + l_g_zero_limbs
				if l_g_zero_bits /= {NATURAL_32} 0 then
					l_gsize := l_gsize + ((l_vp[(l_vsize - 1)]).bit_shift_right (({NATURAL_32} 32 - l_g_zero_bits).to_integer_32) /= {NATURAL_32} 0).to_integer
					if (a_g.item.mp_alloc).to_integer_32 < l_gsize then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_g, l_gsize).do_nothing
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_g_zero_limbs /= 0 then
							l_dst := a_g.item.mp_d
							l_n := l_g_zero_limbs
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp_15 := l_dst
								l_dst := l_dst + 1
								l_tmp_15.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					l_tp := a_g.item.mp_d + l_g_zero_limbs
					l_cy_limb := (create {P_GMP_STATIC}).gmpn_lshift (l_tp, l_vp, l_vsize, l_g_zero_bits.to_natural_32)
					if l_cy_limb /= {NATURAL_32} 0 then
						l_tp[l_vsize] := l_cy_limb
					end
				else
					if (a_g.item.mp_alloc).to_integer_32 < l_gsize then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_g, l_gsize).do_nothing
					end
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_g_zero_limbs /= 0 then
							l_dst_0 := a_g.item.mp_d
							l_n_0 := l_g_zero_limbs
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp_16 := l_dst_0
								l_dst_0 := l_dst_0 + 1
								l_tmp_16.item := (0).to_natural_32
								l_n_0 := l_n_0 - 1
								if not l_n_0.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (a_g.item.mp_d + l_g_zero_limbs, l_vp, l_vsize)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				a_g.item.mp_size := l_gsize.to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
		end

end
