class
	P_GCDEXT_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_gcdext (a_g, a_s, a_t, a_a, a_b: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_asize: INTEGER_32
			l_bsize: INTEGER_32
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_gsize: INTEGER_32
			l_ssize: INTEGER_32
			l_tmp_ssize: CE_ARRAY [INTEGER_32]
			l_gp: CE_POINTER [NATURAL_32]
			l_sp: CE_POINTER [NATURAL_32]
			l_tmp_gp: CE_POINTER [NATURAL_32]
			l_tmp_sp: CE_POINTER [NATURAL_32]
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_ss: CE_POINTER [PD_MPZ_STRUCT]
			l_tt: CE_POINTER [PD_MPZ_STRUCT]
			l_stmp: CE_ARRAY [PD_MPZ_STRUCT]
			l_gtmp: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp_2: CE_POINTER [ANY]
			l_tmp_7: CE_POINTER [ANY]
			l_tmp_12: CE_POINTER [ANY]
			l_tmp_17: CE_POINTER [ANY]
			l_tmp_23: CE_POINTER [ANY]
			l_tmp_28: CE_POINTER [ANY]
			l_x: CE_ARRAY [PD_MPZ_STRUCT]
			l_x2: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_33: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_INTEGER_32_ARRAY} l_tmp_ssize.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_stmp.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_gtmp.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_x.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					if a_a.item.mp_size >= 0 then
						l_asize := (a_a.item.mp_size).to_integer_32
					else
						l_asize := (-a_a.item.mp_size).to_integer_32
					end
					if a_b.item.mp_size >= 0 then
						l_bsize := (a_b.item.mp_size).to_integer_32
					else
						l_bsize := (-a_b.item.mp_size).to_integer_32
					end
					l_ap := a_a.item.mp_d
					l_bp := a_b.item.mp_d
					if not (l_asize > l_bsize) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if l_asize /= l_bsize then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if not (((create {P_GMP_STATIC}).gmpn_cmp (l_ap, l_bp, l_asize)) > 0) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_usize := l_asize
						l_vsize := l_bsize
						if (builtin_expect (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_2 := (l_aaf.new (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_2 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_up := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_2)
						if (builtin_expect (((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_7 := (l_aaf.new (((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_7 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_vp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_7)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_up, l_ap, l_usize)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_vp, l_bp, l_vsize)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_u := a_a
						l_v := a_b
						l_ss := a_s
						l_tt := a_t
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						l_pos := -1 + 9 -- goto _L___0
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___0:
						l_usize := l_bsize
						l_vsize := l_asize
						if (builtin_expect (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_12 := (l_aaf.new (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_12 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_up := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_12)
						if (builtin_expect (((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_17 := (l_aaf.new (((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_17 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_vsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_vp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_17)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_up, l_bp, l_usize)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_vp, l_ap, l_vsize)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_u := a_b
						l_v := a_a
						l_ss := a_t
						l_tt := a_s
				when 10 then -- if done
					if (builtin_expect (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_23 := (l_aaf.new (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp_23 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tmp_gp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_23)
					if (builtin_expect (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_28 := (l_aaf.new (((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp_28 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_usize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tmp_sp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_28)
					if l_vsize = 0 then
						l_tmp_sp[0] := (1).to_natural_32
						l_tmp_ssize.item := (1).to_integer_32
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_tmp_gp, l_up, l_usize)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_gsize := l_usize
					else
						l_gsize := (create {P_GMP_STATIC}).gmpn_gcdext (l_tmp_gp, l_tmp_sp, l_tmp_ssize, l_up, l_usize, l_vp, l_vsize)
					end
					if l_tmp_ssize.item >= 0 then
						l_ssize := l_tmp_ssize.item
					else
						l_ssize := -l_tmp_ssize.item
					end
					l_gtmp.item.mp_d := l_tmp_gp
					l_gtmp.item.mp_size := l_gsize.to_integer_32
					l_stmp.item.mp_d := l_tmp_sp
					if ((l_tmp_ssize.item).bit_xor ((l_u.item.mp_size).to_integer_32)) >= 0 then
						l_stmp.item.mp_size := l_ssize.to_integer_32
					else
						l_stmp.item.mp_size := (-l_ssize).to_integer_32
					end
					if not l_tt.is_void then
						if l_v.item.mp_size = 0 then
							l_tt.item.mp_size := 0
						else
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_x2 := l_x
								l_x2.item.mp_alloc := ((l_ssize + l_usize) + 1).to_integer_32
								if (builtin_expect ((((l_ssize + l_usize) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
									l_tmp_33 := (l_aaf.new ((((l_ssize + l_usize) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								else
									l_tmp_33 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (((l_ssize + l_usize) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								end
								l_x2.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_33)
								l_break := True
							end
							l_break := False;
							(create {P_MUL_STATIC}).gmpz_mul (l_x, l_stmp, l_u);
							(create {P_AORS_STATIC}).gmpz_sub (l_x, l_gtmp, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x));
							(create {P_TDIV_Q_STATIC}).gmpz_tdiv_q (l_tt, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x), l_v)
						end
					end
					if not l_ss.is_void then
						if (l_ss.item.mp_alloc).to_integer_32 < l_ssize then
							(create {P_REALLOC_STATIC}).gmpz_realloc (l_ss, l_ssize).do_nothing
						end
						l_sp := l_ss.item.mp_d
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (l_sp, l_tmp_sp, l_ssize)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						l_ss.item.mp_size := l_stmp.item.mp_size
					end
					if (a_g.item.mp_alloc).to_integer_32 < l_gsize then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_g, l_gsize).do_nothing
					end
					l_gp := a_g.item.mp_d
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_gp, l_tmp_gp, l_gsize)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					a_g.item.mp_size := l_gsize.to_integer_32
					from
					until
						(l_break)
					loop
						l_break := False
						if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
						end
						l_break := True
					end
					l_break := False
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
