class
	P_GMP_IMPL_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	gmp_allocate_func: CE_ROUTINE assign set_gmp_allocate_func
		do
			create Result.make_shared (c_gmp_allocate_func)
		end

	c_gmp_allocate_func: POINTER
		external
			"C inline use <libmpz.h>"
		alias
			"return (EIF_POINTER)__gmp_allocate_func;"
		end

	set_gmp_allocate_func (a_gmp_allocate_func: CE_ROUTINE)
		do
			c_set_gmp_allocate_func (a_gmp_allocate_func.c_pointer)
		end

	c_set_gmp_allocate_func (a_gmp_allocate_func: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_allocate_func = (void *( *)(unsigned int))$a_gmp_allocate_func;"
		end

	gmp_reallocate_func: CE_ROUTINE assign set_gmp_reallocate_func
		do
			create Result.make_shared (c_gmp_reallocate_func)
		end

	c_gmp_reallocate_func: POINTER
		external
			"C inline use <libmpz.h>"
		alias
			"return (EIF_POINTER)__gmp_reallocate_func;"
		end

	set_gmp_reallocate_func (a_gmp_reallocate_func: CE_ROUTINE)
		do
			c_set_gmp_reallocate_func (a_gmp_reallocate_func.c_pointer)
		end

	c_set_gmp_reallocate_func (a_gmp_reallocate_func: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_reallocate_func = (void *( *)(void *, unsigned int, unsigned int))$a_gmp_reallocate_func;"
		end

	gmp_free_func: CE_ROUTINE assign set_gmp_free_func
		do
			create Result.make_shared (c_gmp_free_func)
		end

	c_gmp_free_func: POINTER
		external
			"C inline use <libmpz.h>"
		alias
			"return (EIF_POINTER)__gmp_free_func;"
		end

	set_gmp_free_func (a_gmp_free_func: CE_ROUTINE)
		do
			c_set_gmp_free_func (a_gmp_free_func.c_pointer)
		end

	c_set_gmp_free_func (a_gmp_free_func: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_free_func = (void( *)(void *, unsigned int))$a_gmp_free_func;"
		end

	gmp_fib_table: CE_ARRAY [NATURAL_32] assign set_gmp_fib_table
		do
			create {CE_NATURAL_32_ARRAY} Result.make_shared_from_pointer (c_gmp_fib_table)
		end

	c_gmp_fib_table: POINTER
		external
			"C inline use <libmpz.h>"
		alias
			"return (EIF_POINTER)__gmp_fib_table;"
		end

	set_gmp_fib_table (a_gmp_fib_table: CE_ARRAY [NATURAL_32])
		do
			c_set_gmp_fib_table (a_gmp_fib_table.c_pointer)
		end

	c_set_gmp_fib_table (a_gmp_fib_table: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"printf(%"NATIVE_FUNCTIONS_WRITER.write_native_variable: AST_ARRAY_TYPE\n%");"
		end

	gmpn_bases: CE_ARRAY [PD_BASES] assign set_gmpn_bases
		do
			create {CE_CLASS_ARRAY [PD_BASES]} Result.make_shared (c_gmpn_bases, <<257>>)
		end

	c_gmpn_bases: POINTER
		external
			"C inline use <libmpz.h>"
		alias
			"return (EIF_POINTER)__gmpn_bases;"
		end

	set_gmpn_bases (a_gmpn_bases: CE_ARRAY [PD_BASES])
		do
			c_set_gmpn_bases (a_gmpn_bases.c_pointer)
		end

	c_set_gmpn_bases (a_gmpn_bases: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"printf(%"NATIVE_FUNCTIONS_WRITER.write_native_variable: AST_ARRAY_TYPE\n%");"
		end

	gmp_rands_initialized: INTEGER_8 assign set_gmp_rands_initialized
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmp_rands_initialized;"
		end

	set_gmp_rands_initialized (a_gmp_rands_initialized: INTEGER_8)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_rands_initialized = $a_gmp_rands_initialized;"
		end

	gmp_rands: CE_ARRAY [PD_GMP_RANDSTATE_STRUCT] assign set_gmp_rands
		do
			create {CE_CLASS_ARRAY [PD_GMP_RANDSTATE_STRUCT]} Result.make_shared (c_gmp_rands, <<1>>)
		end

	c_gmp_rands: POINTER
		external
			"C inline use <libmpz.h>"
		alias
			"return (EIF_POINTER)__gmp_rands;"
		end

	set_gmp_rands (a_gmp_rands: CE_ARRAY [PD_GMP_RANDSTATE_STRUCT])
		do
			c_set_gmp_rands (a_gmp_rands.c_pointer)
		end

	c_set_gmp_rands (a_gmp_rands: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"printf(%"NATIVE_FUNCTIONS_WRITER.write_native_variable: AST_ARRAY_TYPE\n%");"
		end

feature {ANY} -- public routines

	gmp_tmp_reentrant_alloc (a_arg1: CE_POINTER [CE_POINTER [PD_TMP_REENTRANT_T]]; a_arg2: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_gmp_tmp_reentrant_alloc (a_arg1.c_pointer, a_arg2))
		end

	c_gmp_tmp_reentrant_alloc (a_arg1: POINTER; a_arg2: NATURAL_32): POINTER
		external
			"C inline use <libmpz.h>"
		alias
			"return (EIF_POINTER)__gmp_tmp_reentrant_alloc($a_arg1, $a_arg2);"
		end

	gmp_tmp_reentrant_free (a_arg1: CE_POINTER [PD_TMP_REENTRANT_T])
		do
			c_gmp_tmp_reentrant_free (a_arg1.c_pointer)
		end

	c_gmp_tmp_reentrant_free (a_arg1: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_tmp_reentrant_free($a_arg1);"
		end

	gmpn_divexact_1 (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32)
		do
			c_gmpn_divexact_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_divexact_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_divexact_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmp_divide_by_zero
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_divide_by_zero();"
		end

	gmp_extract_double (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: REAL_64): INTEGER_32
		do
			Result := c_gmp_extract_double (a_arg1.c_pointer, a_arg2)
		end

	c_gmp_extract_double (a_arg1: POINTER; a_arg2: REAL_64): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmp_extract_double($a_arg1, $a_arg2);"
		end

	gmp_invalid_operation
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_invalid_operation();"
		end

	gmpn_divisible_p (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): INTEGER_32
		do
			Result := c_gmpn_divisible_p (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_divisible_p (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_divisible_p($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_modexact_1c_odd (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3, a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_modexact_1c_odd (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4)
		end

	c_gmpn_modexact_1c_odd (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: NATURAL_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_modexact_1c_odd($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_divexact (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: CE_POINTER [NATURAL_32]; a_arg5: INTEGER_32)
		do
			c_gmpn_divexact (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4.c_pointer, a_arg5)
		end

	c_gmpn_divexact (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: POINTER; a_arg5: INTEGER_32)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_divexact($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_bdiv_dbm1c (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4, a_arg5: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_bdiv_dbm1c (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4, a_arg5)
		end

	c_gmpn_bdiv_dbm1c (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32; a_arg5: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_bdiv_dbm1c($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_modexact_1_odd (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_modexact_1_odd (a_arg1.c_pointer, a_arg2, a_arg3)
		end

	c_gmpn_modexact_1_odd (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: NATURAL_32): NATURAL_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_modexact_1_odd($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_fib2_ui (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: NATURAL_32): INTEGER_32
		do
			Result := c_gmpn_fib2_ui (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_fib2_ui (a_arg1: POINTER; a_arg2: POINTER; a_arg3: NATURAL_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_fib2_ui($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_get_d (a_arg1: CE_POINTER [NATURAL_32]; a_arg2, a_arg3, a_arg4: INTEGER_32): REAL_64
		do
			Result := c_gmpn_get_d (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4)
		end

	c_gmpn_get_d (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: INTEGER_32; a_arg4: INTEGER_32): REAL_64
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_get_d($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_jacobi_base (a_arg1: NATURAL_32; a_arg2: NATURAL_32; a_arg3: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_jacobi_base($a_arg1, $a_arg2, $a_arg3);"
		end

	gmp_assert_fail (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [INTEGER_8])
		do
			c_gmp_assert_fail (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer)
		end

	c_gmp_assert_fail (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_assert_fail($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_mullo_n (a_arg1, a_arg2, a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32)
		do
			c_gmpn_mullo_n (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_mullo_n (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_mullo_n($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_binvert (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: CE_POINTER [NATURAL_32])
		do
			c_gmpn_binvert (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4.c_pointer)
		end

	c_gmpn_binvert (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_binvert($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_binvert_itch (a_arg1: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_binvert_itch($a_arg1);"
		end

	gmpn_powm (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: CE_POINTER [NATURAL_32]; a_arg5: INTEGER_32; a_arg6: CE_POINTER [NATURAL_32]; a_arg7: INTEGER_32; a_arg8: CE_POINTER [NATURAL_32])
		do
			c_gmpn_powm (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4.c_pointer, a_arg5, a_arg6.c_pointer, a_arg7, a_arg8.c_pointer)
		end

	c_gmpn_powm (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: POINTER; a_arg5: INTEGER_32; a_arg6: POINTER; a_arg7: INTEGER_32; a_arg8: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_powm($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8);"
		end

	gmpn_powlo (a_arg1, a_arg2, a_arg3: CE_POINTER [NATURAL_32]; a_arg4, a_arg5: INTEGER_32; a_arg6: CE_POINTER [NATURAL_32])
		do
			c_gmpn_powlo (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4, a_arg5, a_arg6.c_pointer)
		end

	c_gmpn_powlo (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: INTEGER_32; a_arg6: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_powlo($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6);"
		end

	gmpn_powm_sec (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: CE_POINTER [NATURAL_32]; a_arg5: INTEGER_32; a_arg6: CE_POINTER [NATURAL_32]; a_arg7: INTEGER_32; a_arg8: CE_POINTER [NATURAL_32])
		do
			c_gmpn_powm_sec (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4.c_pointer, a_arg5, a_arg6.c_pointer, a_arg7, a_arg8.c_pointer)
		end

	c_gmpn_powm_sec (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: POINTER; a_arg5: INTEGER_32; a_arg6: POINTER; a_arg7: INTEGER_32; a_arg8: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_powm_sec($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8);"
		end

	gmpn_powm_sec_itch (a_arg1: INTEGER_32; a_arg2: INTEGER_32; a_arg3: INTEGER_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_powm_sec_itch($a_arg1, $a_arg2, $a_arg3);"
		end

	gmp_randinit_mt_noseed (a_arg1: CE_POINTER [PD_GMP_RANDSTATE_STRUCT])
		do
			c_gmp_randinit_mt_noseed (a_arg1.c_pointer)
		end

	c_gmp_randinit_mt_noseed (a_arg1: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_randinit_mt_noseed($a_arg1);"
		end

	gmpn_rootrem (a_arg1, a_arg2, a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5: NATURAL_32): INTEGER_32
		do
			Result := c_gmpn_rootrem (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4, a_arg5)
		end

	c_gmpn_rootrem (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: NATURAL_32): INTEGER_32
		external
			"C inline use <libmpz.h>"
		alias
			"return __gmpn_rootrem($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmp_sqrt_of_negative
		external
			"C inline use <libmpz.h>"
		alias
			"__gmp_sqrt_of_negative();"
		end

	gmpn_div_q (a_arg1, a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: CE_POINTER [NATURAL_32]; a_arg5: INTEGER_32; a_arg6: CE_POINTER [NATURAL_32])
		do
			c_gmpn_div_q (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4.c_pointer, a_arg5, a_arg6.c_pointer)
		end

	c_gmpn_div_q (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: POINTER; a_arg5: INTEGER_32; a_arg6: POINTER)
		external
			"C inline use <libmpz.h>"
		alias
			"__gmpn_div_q($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6);"
		end

end
