class
	P_MILLERRABIN_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_millerrabin (a_n: CE_POINTER [PD_MPZ_STRUCT]; a_reps: INTEGER_32): INTEGER_32
		local
			l_r: INTEGER_32
			l_nm1: CE_ARRAY [PD_MPZ_STRUCT]
			l_nm3: CE_ARRAY [PD_MPZ_STRUCT]
			l_x: CE_ARRAY [PD_MPZ_STRUCT]
			l_y: CE_ARRAY [PD_MPZ_STRUCT]
			l_q: CE_ARRAY [PD_MPZ_STRUCT]
			l_k: NATURAL_32
			l_rstate: CE_ARRAY [PD_GMP_RANDSTATE_STRUCT]
			l_is_prime: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_x2: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_2: CE_POINTER [ANY]
			l_x_0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_7: CE_POINTER [ANY]
			l_x_1: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_12: CE_POINTER [ANY]
			l_x_2: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_20: CE_POINTER [ANY]
			l_x_3: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_25: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_nm1.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_nm3.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_x.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_y.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_q.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GMP_RANDSTATE_STRUCT]} l_rstate.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_x2 := l_nm1
				l_x2.item.mp_alloc := (a_n.item.mp_size + 1)
				if (builtin_expect (((a_n.item.mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_2 := (l_aaf.new ((a_n.item.mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
				else
					l_tmp_2 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (a_n.item.mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
				end
				l_x2.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_2)
				l_break := True
			end
			l_break := False;
			(create {P_AORS_UI_STATIC}).gmpz_sub_ui (l_nm1, a_n, {NATURAL_32} 1)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_x_0 := l_x
				l_x_0.item.mp_alloc := (a_n.item.mp_size + 1)
				if (builtin_expect (((a_n.item.mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_7 := (l_aaf.new ((a_n.item.mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
				else
					l_tmp_7 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (a_n.item.mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
				end
				l_x_0.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_7)
				l_break := True
			end
			l_break := False
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_x_1 := l_y
				l_x_1.item.mp_alloc := 2 * a_n.item.mp_size
				if (builtin_expect (((2 * a_n.item.mp_size).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp_12 := (l_aaf.new ((2 * a_n.item.mp_size).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
				else
					l_tmp_12 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (2 * a_n.item.mp_size).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
				end
				l_x_1.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_12)
				l_break := True
			end
			l_break := False;
			(create {P_SET_UI_STATIC}).gmpz_set_ui (l_x, {NATURAL_32} 210);
			(create {P_POWM_STATIC}).gmpz_powm (l_y, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), a_n)
			if ((create {P_CMP_UI_STATIC}).gmpz_cmp_ui (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_y), {NATURAL_32} 1)) /= 0 then
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
				Result := 0
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_x_2 := l_q
					l_x_2.item.mp_alloc := a_n.item.mp_size
					if (builtin_expect (((a_n.item.mp_size).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_20 := (l_aaf.new ((a_n.item.mp_size).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
					else
						l_tmp_20 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (a_n.item.mp_size).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
					end
					l_x_2.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_20)
					l_break := True
				end
				l_break := False
				l_k := (create {P_SCAN1_STATIC}).gmpz_scan1 (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), (0).to_natural_32);
				(create {P_TDIV_Q_2EXP_STATIC}).gmpz_tdiv_q_2exp (l_q, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), l_k)
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_x_3 := l_nm3
					l_x_3.item.mp_alloc := (a_n.item.mp_size + 1)
					if (builtin_expect (((a_n.item.mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_25 := (l_aaf.new ((a_n.item.mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
					else
						l_tmp_25 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (a_n.item.mp_size + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
					end
					l_x_3.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_25)
					l_break := True
				end
				l_break := False;
				(create {P_AORS_UI_STATIC}).gmpz_sub_ui (l_nm3, a_n, {NATURAL_32} 3);
				(create {P_GMP_STATIC}).gmp_randinit_default (create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (l_rstate))
				l_is_prime := 1
				l_r := 0
				from
				until
					(l_break)
				loop
					l_break := False
					if l_r < a_reps then
						if not l_is_prime.to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_return or l_break) then
						(create {P_URANDOMM_STATIC}).gmpz_urandomm (l_x, create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (l_rstate), create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm3));
						(create {P_AORS_UI_STATIC}).gmpz_add_ui (l_x, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x), {NATURAL_32} 2)
						l_is_prime := millerrabin (a_n, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nm1), l_x, l_y, create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_q), l_k)
						l_r := l_r + 1
					end
				end
				l_break := False;
				(create {P_GMP_STATIC}).gmp_randclear (create {CE_CLASS_POINTER [PD_GMP_RANDSTATE_STRUCT]}.make_cast (l_rstate))
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
				Result := l_is_prime
			end
		end

	millerrabin (a_n, a_nm1, a_x, a_y, a_q: CE_POINTER [PD_MPZ_STRUCT]; a_k: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_return: BOOLEAN
		do
			(create {P_POWM_STATIC}).gmpz_powm (a_y, a_x, a_q, a_n)
			if ((create {P_CMP_UI_STATIC}).gmpz_cmp_ui (a_y, {NATURAL_32} 1)) = 0 then
				Result := 1
				l_return := True
			elseif ((create {P_CMP_STATIC}).gmpz_cmp (a_y, a_nm1)) = 0 then
				Result := 1
				l_return := True
			end
			if not l_return then
				l_i := {NATURAL_32} 1
				from
				until
					not (not (l_return) and then (l_i < a_k))
				loop
					(create {P_POWM_UI_STATIC}).gmpz_powm_ui (a_y, a_y, {NATURAL_32} 2, a_n)
					if ((create {P_CMP_STATIC}).gmpz_cmp (a_y, a_nm1)) = 0 then
						Result := 1
						l_return := True
					end
					if not l_return then
						if ((create {P_CMP_UI_STATIC}).gmpz_cmp_ui (a_y, {NATURAL_32} 1)) = 0 then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_i := l_i + 1
					end
				end
			end
			if not l_return then
				Result := 0
			end
		end

end
