class
	P_MUL_2EXP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_mul_2exp (a_w, a_u: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		local
			l_cnt: NATURAL_32
			l_usize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_tmp: INTEGER_32
			l_wsize: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_wp: CE_POINTER [NATURAL_32]
			l_wlimb: NATURAL_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp_0: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_cnt := a_cnt
			l_usize := (a_u.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_tmp := l_usize
			else
				l_tmp := -l_usize
			end
			l_abs_usize := l_tmp
			if l_usize = 0 then
				a_w.item.mp_size := 0
				l_return := True
			end
			if not l_return then
				l_limb_cnt := (l_cnt // {NATURAL_32} 32).to_integer_32
				l_wsize := (l_abs_usize + l_limb_cnt) + 1
				if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_wsize).do_nothing
				end
				l_wp := a_w.item.mp_d
				l_wsize := l_abs_usize + l_limb_cnt
				l_cnt := l_cnt \\ ({NATURAL_32} 32)
				if l_cnt /= {NATURAL_32} 0 then
					l_wlimb := (create {P_GMP_STATIC}).gmpn_lshift (l_wp + l_limb_cnt, a_u.item.mp_d, l_abs_usize, l_cnt.to_natural_32)
					if l_wlimb /= {NATURAL_32} 0 then
						l_wp[l_wsize] := l_wlimb
						l_wsize := l_wsize + 1
					end
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyd (l_wp + l_limb_cnt, a_u.item.mp_d, l_abs_usize)
						l_break := True
					end
					l_break := False
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_limb_cnt /= 0 then
						l_dst := l_wp
						l_n := l_limb_cnt
						from
						until
							(l_break)
						loop
							l_break := False
							l_tmp_0 := l_dst
							l_dst := l_dst + 1
							l_tmp_0.item := (0).to_natural_32
							l_n := l_n - 1
							if not l_n.to_boolean then
								l_break := True
							end
						end
						l_break := False
					end
					l_break := True
				end
				l_break := False
				if l_usize >= 0 then
					a_w.item.mp_size := l_wsize.to_integer_32
				else
					a_w.item.mp_size := (-l_wsize).to_integer_32
				end
			end
		end

end
