class
	P_ROOTREM_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_rootrem (a_root, a_rem, a_u: CE_POINTER [PD_MPZ_STRUCT]; a_nth: NATURAL_32)
		local
			l_rootp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_remp: CE_POINTER [NATURAL_32]
			l_us: INTEGER_32
			l_un: INTEGER_32
			l_rootn: INTEGER_32
			l_remn: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp_5: CE_POINTER [ANY]
			l_tmp_13: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_us := (a_u.item.mp_size).to_integer_32
					if l_us < 0 then
						if ((a_nth).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							(create {P_GMP_IMPL_STATIC}).gmp_sqrt_of_negative
						end
					end
					if a_nth = {NATURAL_32} 0 then
						(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
					end
					if l_us = 0 then
						if not a_root.is_void then
							a_root.item.mp_size := 0
						end
						a_rem.item.mp_size := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if l_us >= 0 then
							l_un := l_us
						else
							l_un := -l_us
						end
						l_rootn := ((l_un - 1).to_natural_32 // a_nth + {NATURAL_32} 1).to_integer_32
						l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if a_root.is_void then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not a_u.is_equal (a_root) then
							if (builtin_expect ((l_rootn > (a_root.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
								l_rootp := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_REALLOC_STATIC}).gmpz_realloc (a_root, l_rootn)))
							else
								l_rootp := a_root.item.mp_d
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (builtin_expect ((l_rootn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_5 := (l_aaf.new ((l_rootn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_5 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_rootn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_rootp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_5)
				when 5 then
						if not a_u.is_equal (a_rem) then
							if (builtin_expect ((l_un > (a_rem.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
								l_remp := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_REALLOC_STATIC}).gmpz_realloc (a_rem, l_un)))
							else
								l_remp := a_rem.item.mp_d
							end
						else
							if (builtin_expect ((l_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_13 := (l_aaf.new ((l_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_13 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_remp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_13)
						end
						l_up := a_u.item.mp_d
						if a_nth = {NATURAL_32} 1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_rootp, l_up, l_un)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							l_remn := (0).to_integer_32
						else
							l_remn := (create {P_GMP_IMPL_STATIC}).gmpn_rootrem (l_rootp, l_remp, l_up, l_un, a_nth)
						end
						if not a_root.is_void then
							if l_us >= 0 then
								a_root.item.mp_size := l_rootn.to_integer_32
							else
								a_root.item.mp_size := (-l_rootn).to_integer_32
							end
							if a_u.is_equal (a_root) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_up, l_rootp, l_rootn)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							elseif a_u.is_equal (a_rem) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_up, l_remp, l_remn)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
							end
						end
						a_rem.item.mp_size := l_remn.to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
