class
	P_SET_F_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_set_f (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT])
		local
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_exp: INTEGER_32
			l_zeros: INTEGER_32
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp_0: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_exp := a_u.item.mp_exp
			if l_exp <= 0 then
				a_w.item.mp_size := 0
				l_return := True
			end
			if not l_return then
				if (builtin_expect ((l_exp > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_exp).do_nothing
				end
				l_wp := a_w.item.mp_d
				l_up := a_u.item.mp_d
				l_size := (a_u.item.mp_size).to_integer_32
				if l_size >= 0 then
					a_w.item.mp_size := l_exp.to_integer_32
				else
					a_w.item.mp_size := (-l_exp).to_integer_32
				end
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				if l_exp > l_size then
					l_zeros := l_exp - l_size
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_zeros /= 0 then
							l_dst := l_wp
							l_n := l_zeros
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp_0 := l_dst
								l_dst := l_dst + 1
								l_tmp_0.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					l_wp := l_wp + l_zeros
				else
					l_up := l_up + (l_size - l_exp)
					l_size := l_exp
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_wp, l_up, l_size)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
		end

end
