class
	P_SQRT_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_sqrt (a_root, a_op: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_op_size: INTEGER_32
			l_root_size: INTEGER_32
			l_root_ptr: CE_POINTER [NATURAL_32]
			l_op_ptr: CE_POINTER [NATURAL_32]
			l_free_me: CE_POINTER [NATURAL_32]
			l_free_me_size: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp_3: CE_POINTER [ANY]
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			l_free_me := create {CE_NATURAL_32_POINTER}.make_shared (default_pointer)
			l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_op_size := (a_op.item.mp_size).to_integer_32
			if l_op_size <= 0 then
				if l_op_size < 0 then
					(create {P_GMP_IMPL_STATIC}).gmp_sqrt_of_negative
				end
				a_root.item.mp_size := 0
				l_return := True
			end
			if not l_return then
				l_root_size := (l_op_size + 1) // 2
				l_root_ptr := a_root.item.mp_d
				l_op_ptr := a_op.item.mp_d
				if (a_root.item.mp_alloc).to_integer_32 < l_root_size then
					if l_root_ptr.is_equal (l_op_ptr) then
						l_free_me := l_root_ptr
						l_free_me_size := (a_root.item.mp_alloc).to_integer_32
					else
						(create {P_GMP_IMPL_STATIC}).gmp_free_func.call ([create {CE_VOID_POINTER}.make_cast (l_root_ptr), (a_root.item.mp_alloc * 4).to_natural_32])
					end
					a_root.item.mp_alloc := l_root_size.to_integer_32
					l_root_ptr := create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_allocate_func.pointer_item ([(l_root_size * 4).to_natural_32]))))
					a_root.item.mp_d := l_root_ptr
				elseif l_root_ptr.is_equal (l_op_ptr) then
					if (builtin_expect ((l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_3 := (l_aaf.new ((l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp_3 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_op_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_op_ptr := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_3)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_op_ptr, l_root_ptr, l_op_size)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
				end
				(create {P_GMP_STATIC}).gmpn_sqrtrem (l_root_ptr, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer), l_op_ptr, l_op_size).do_nothing
				a_root.item.mp_size := l_root_size.to_integer_32
				if not l_free_me.is_void then
					(create {P_GMP_IMPL_STATIC}).gmp_free_func.call ([create {CE_VOID_POINTER}.make_cast (l_free_me), (l_free_me_size * 4).to_natural_32])
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
		end

end
