class
	P_TDIV_R_2EXP_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_tdiv_r_2exp (a_res, a_in: CE_POINTER [PD_MPZ_STRUCT]; a_cnt: NATURAL_32)
		local
			l_in_size: INTEGER_32
			l_tmp: INTEGER_32
			l_res_size: INTEGER_32
			l_limb_cnt: INTEGER_32
			l_in_ptr: CE_POINTER [NATURAL_32]
			l_x: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			if a_in.item.mp_size >= 0 then
				l_tmp := a_in.item.mp_size
			else
				l_tmp := -a_in.item.mp_size
			end
			l_in_size := l_tmp.to_integer_32
			l_limb_cnt := (a_cnt // {NATURAL_32} 32).to_integer_32
			l_in_ptr := a_in.item.mp_d
			if l_in_size > l_limb_cnt then
				l_x := ((l_in_ptr[l_limb_cnt]).bit_and (((({NATURAL_32} 1).bit_shift_left ((a_cnt \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1)))
				if l_x /= {NATURAL_32} 0 then
					l_res_size := l_limb_cnt + 1
					if (a_res.item.mp_alloc).to_integer_32 < l_res_size then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_res, l_res_size).do_nothing
					end
					a_res.item.mp_d[l_limb_cnt] := l_x
				else
					l_res_size := l_limb_cnt
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							not (not (l_break) and then (l_res_size > 0))
						loop
							l_break := False
							if l_in_ptr[(l_res_size - 1)] /= {NATURAL_32} 0 then
								l_break := True
							end
							if not (l_break) then
								l_res_size := l_res_size - 1
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if (a_res.item.mp_alloc).to_integer_32 < l_res_size then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_res, l_res_size).do_nothing
					end
					l_limb_cnt := l_res_size
				end
			else
				l_res_size := l_in_size
				if (a_res.item.mp_alloc).to_integer_32 < l_res_size then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_res, l_res_size).do_nothing
				end
				l_limb_cnt := l_res_size
			end
			if not a_res.is_equal (a_in) then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (a_res.item.mp_d, a_in.item.mp_d, l_limb_cnt)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
			if a_in.item.mp_size >= 0 then
				a_res.item.mp_size := l_res_size.to_integer_32
			else
				a_res.item.mp_size := (-l_res_size).to_integer_32
			end
		end

end
