class
	P_URANDOMB_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_urandomb (a_rop: CE_POINTER [PD_MPZ_STRUCT]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_return, l_break: BOOLEAN
		do
			l_size := ((a_nbits + {NATURAL_32} 31) // {NATURAL_32} 32).to_integer_32
			if (builtin_expect ((l_size > (a_rop.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
				l_rp := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_REALLOC_STATIC}).gmpz_realloc (a_rop, l_size)))
			else
				l_rp := a_rop.item.mp_d
			end
			from
			until
				(l_break)
			loop
				l_break := False
				l_rstate := a_rstate;
				((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate, l_rp, a_nbits])
				l_break := True
			end
			l_break := False
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					not (not (l_break) and then (l_size > 0))
				loop
					l_break := False
					if l_rp[(l_size - 1)] /= {NATURAL_32} 0 then
						l_break := True
					end
					if not (l_break) then
						l_size := l_size - 1
					end
				end
				l_break := False
				l_break := True
			end
			l_break := False
			a_rop.item.mp_size := l_size.to_integer_32
		end

end
