class
	P_URANDOMM_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_urandomm (a_rop: CE_POINTER [PD_MPZ_STRUCT]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_n: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_nlast: CE_POINTER [NATURAL_32]
			l_nbits: INTEGER_32
			l_size: INTEGER_32
			l_count: INTEGER_32
			l_pow2: INTEGER_32
			l_cmp: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tp: CE_POINTER [NATURAL_32]
			l_tmp_2: CE_POINTER [ANY]
			l_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l_gmp_i: INTEGER_32
			l_gmp_x: NATURAL_32
			l_gmp_y: NATURAL_32
			l_return, l_break: BOOLEAN
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)

			if a_n.item.mp_size >= 0 then
				l_size := (a_n.item.mp_size).to_integer_32
			else
				l_size := (-a_n.item.mp_size).to_integer_32
			end
			if l_size = 0 then
				(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
			end
			l_nlast := a_n.item.mp_d + (l_size - 1)
			l_pow2 := (((l_nlast.item).bit_and ((l_nlast.item - {NATURAL_32} 1))) = {NATURAL_32} 0).to_integer
			if l_pow2 /= 0 then
				l_np := a_n.item.mp_d
				from
				until
					not (not (l_break) and then ((l_np.c_pointer.to_integer_32).to_natural_32 < (l_nlast.c_pointer.to_integer_32).to_natural_32))
				loop
					l_break := False
					if l_np.item /= {NATURAL_32} 0 then
						l_pow2 := 0
						l_break := True
					end
					if not (l_break) then
						l_np := l_np + 1
					end
				end
				l_break := False
			end
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_count := builtin_clzl (l_nlast.item)
				l_break := True
			end
			l_break := False
			l_nbits := (l_size * 32 - l_count.to_integer_32) - l_pow2.to_integer_32
			if l_nbits = 0 then
				a_rop.item.mp_size := 0
				l_return := True
			end
			if not l_return then
				l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_np := a_n.item.mp_d
				if a_rop.is_equal (a_n) then
					if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp_2 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp_2 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_2)
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_tp, l_np, l_size)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					l_np := l_tp
				end
				if (builtin_expect ((l_size > (a_rop.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					l_rp := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_REALLOC_STATIC}).gmpz_realloc (a_rop, l_size)))
				else
					l_rp := a_rop.item.mp_d
				end
				l_rp[(l_size - 1)] := (0).to_natural_32
				l_count := 80
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						l_rstate := a_rstate;
						((create {CE_CLASS_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l_rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l_rstate, l_rp, l_nbits.to_natural_32])
						l_break := True
					end
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_cmp := 0
						l_gmp_i := l_size
						from
						until
							(l_break)
						loop
							l_break := False
							l_gmp_i := l_gmp_i - 1
							if not (l_gmp_i >= 0) then
								l_break := True
							end
							if not (l_return or l_break) then
								l_gmp_x := l_rp[l_gmp_i]
								l_gmp_y := l_np[l_gmp_i]
								if l_gmp_x /= l_gmp_y then
									if l_gmp_x > l_gmp_y then
										l_cmp := 1
									else
										l_cmp := -1
									end
									l_break := True
								end
							end
						end
						l_break := False
						l_break := True
					end
					l_break := False
					if l_cmp >= 0 then
						l_count := l_count - 1
						if l_count = 0 then
							l_break := True
						end
					else
						l_break := True
					end
				end
				l_break := False
				if l_count = 0 then
					(create {P_GMP_STATIC}).gmpn_sub_n (l_rp, l_rp, l_np, l_size).do_nothing
				end
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						not (not (l_break) and then (l_size > 0))
					loop
						l_break := False
						if l_rp[(l_size - 1)] /= {NATURAL_32} 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							l_size := l_size - 1
						end
					end
					l_break := False
					l_break := True
				end
				l_break := False
				a_rop.item.mp_size := l_size.to_integer_32
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
			end
		end

end
