class
	PD_IEEE_DOUBLE_EXTRACT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_s: PD_S
				a_d: REAL_64
			])
		require else
			a_data /= Void
		do
			make
			s.c_pointer.memory_copy (a_data.a_s.c_pointer, a_data.a_s.structure_size)
			Current.d := a_data.a_d
		end

feature {ANY} -- fields

	s: PD_S
		once ("OBJECT")
			create Result.make_shared (c__s (internal_c_pointer))
		end

	d: REAL_64 assign set_d
		do
			Result := c__d (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_d (a_d: REAL_64)
		do
			c__set_d (internal_c_pointer, a_d)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return sizeof(union ieee_double_extract);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return __alignof__(union ieee_double_extract);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_union (<<>>)
			Result.alignment := structure_alignment
		end

	c__s (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)&((union ieee_double_extract *)$a_c_pointer)->s;"
		end

	c__d (a_c_pointer: POINTER): REAL_64
		external
			"C inline use %"libmpz.h%""
		alias
			"return ((union ieee_double_extract *)$a_c_pointer)->d;"
		end

	c__set_d (a_c_pointer: POINTER; a_d: REAL_64)
		external
			"C inline use %"libmpz.h%""
		alias
			"((union ieee_double_extract *)$a_c_pointer)->d = $a_d;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmpz.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "s") == 0) return offsetof(union ieee_double_extract, s);
				if(strcmp($a_field_name, "d") == 0) return offsetof(union ieee_double_extract, d);
				fprintf(stderr, "union ieee_double_extract.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
