class
	PD_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_manl: NATURAL_32
				a_manh: NATURAL_32
				a_exp: NATURAL_32
				a_sig: NATURAL_32
			])
		require else
			a_data /= Void
		do
			make
			Current.manl := a_data.a_manl
			Current.manh := a_data.a_manh
			Current.exp := a_data.a_exp
			Current.sig := a_data.a_sig
		end

feature {ANY} -- fields

	manl: NATURAL_32 assign set_manl
		do
			Result := c__manl (internal_c_pointer)
		end

	manh: NATURAL_32 assign set_manh
		do
			Result := c__manh (internal_c_pointer)
		end

	exp: NATURAL_32 assign set_exp
		do
			Result := c__exp (internal_c_pointer)
		end

	sig: NATURAL_32 assign set_sig
		do
			Result := c__sig (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_manl (a_manl: NATURAL_32)
		do
			c__set_manl (internal_c_pointer, a_manl)
		end

	set_manh (a_manh: NATURAL_32)
		do
			c__set_manh (internal_c_pointer, a_manh)
		end

	set_exp (a_exp: NATURAL_32)
		do
			c__set_exp (internal_c_pointer, a_exp)
		end

	set_sig (a_sig: NATURAL_32)
		do
			c__set_sig (internal_c_pointer, a_sig)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return sizeof(struct __anonstruct_s_13);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return __alignof__(struct __anonstruct_s_13);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__manl (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return ((struct __anonstruct_s_13 *)$a_c_pointer)->manl;"
		end

	c__manh (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return ((struct __anonstruct_s_13 *)$a_c_pointer)->manh;"
		end

	c__exp (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return ((struct __anonstruct_s_13 *)$a_c_pointer)->exp;"
		end

	c__sig (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return ((struct __anonstruct_s_13 *)$a_c_pointer)->sig;"
		end

	c__set_manl (a_c_pointer: POINTER; a_manl: NATURAL_32)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct_s_13 *)$a_c_pointer)->manl = $a_manl;"
		end

	c__set_manh (a_c_pointer: POINTER; a_manh: NATURAL_32)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct_s_13 *)$a_c_pointer)->manh = $a_manh;"
		end

	c__set_exp (a_c_pointer: POINTER; a_exp: NATURAL_32)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct_s_13 *)$a_c_pointer)->exp = $a_exp;"
		end

	c__set_sig (a_c_pointer: POINTER; a_sig: NATURAL_32)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct __anonstruct_s_13 *)$a_c_pointer)->sig = $a_sig;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmpz.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				fprintf(stderr, "struct __anonstruct_s_13.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
