class
	PD_TMP_REENTRANT_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_next: CE_POINTER [PD_TMP_REENTRANT_T]
				a_size: NATURAL_32
			])
		require else
			a_data /= Void
		do
			make
			Current.next := a_data.a_next
			Current.size := a_data.a_size
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_TMP_REENTRANT_T] assign set_next
		do
			create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]} Result.make_shared (c__next (internal_c_pointer))
		end

	size: NATURAL_32 assign set_size
		do
			Result := c__size (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_TMP_REENTRANT_T])
		do
			c__set_next (internal_c_pointer, a_next.c_pointer)
		end

	set_size (a_size: NATURAL_32)
		do
			c__set_size (internal_c_pointer, a_size)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return sizeof(struct tmp_reentrant_t);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return __alignof__(struct tmp_reentrant_t);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__next (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmpz.h%""
		alias
			"return (EIF_POINTER)((struct tmp_reentrant_t *)$a_c_pointer)->next;"
		end

	c__size (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmpz.h%""
		alias
			"return ((struct tmp_reentrant_t *)$a_c_pointer)->size;"
		end

	c__set_next (a_c_pointer: POINTER; a_next: POINTER)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct tmp_reentrant_t *)$a_c_pointer)->next = $a_next;"
		end

	c__set_size (a_c_pointer: POINTER; a_size: NATURAL_32)
		external
			"C inline use %"libmpz.h%""
		alias
			"((struct tmp_reentrant_t *)$a_c_pointer)->size = $a_size;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmpz.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "next") == 0) return offsetof(struct tmp_reentrant_t, next);
				if(strcmp($a_field_name, "size") == 0) return offsetof(struct tmp_reentrant_t, size);
				fprintf(stderr, "struct tmp_reentrant_t.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
